function LinkHandler()
{
	this.linkList = [];
}

LinkHandler.prototype.parseURLs = text => text.match(/\bhttps?:\/\/\S+/gi);

LinkHandler.prototype.searchTextAndAddUrl = function (text)
{
	let urls = this.parseURLs(text);
	if (urls != null)
		this.linkList.unshift(urls.reverse())
}

// Returns false if successful
LinkHandler.prototype.openLink = function (value)
{
	let i = value;
	if (typeof i == 'object') i = i[0];
	if (typeof i == 'string') i = i.trim() == '' ? 0 : i.trim();
	i = parseInt(i);
	if (!Number.isInteger(i) || i < 0 || i >= this.linkList.length)
		return 'No links or invalid index.';
	Engine.OpenURL(String(this.linkList[i]));
	return false;
}

// Returns pretty info list of all links
LinkHandler.prototype.getInfo = function ()
{
	let title = `Link list (${this.linkList.length}):`;
	let textList = this.linkList.map((link, index) => `${index} : ${link}`).reverse()
	return [title, ...textList].join('/n');
}
