function MorseCode()
{};
MorseCode.description = "Translate automatically your messages to morse code and viceversa."
MorseCode.dictTextMorse = {
	"a": ".-",
	"b": "-...",
	"c": "-.-.",
	"d": "-..",
	"e": ".",
	"f": "..-.",
	"g": "--.",
	"h": "....",
	"i": "..",
	"j": ".---",
	"k": "-.-",
	"l": ".-..",
	"m": "--",
	"n": "-.",
	"o": "---",
	"p": ".--.",
	"q": "--.-",
	"r": ".-.",
	"s": "...",
	"t": "-",
	"u": "..-",
	"v": "...-",
	"w": ".--",
	"x": "-..-",
	"y": "-.--",
	"z": "--..",
	"0": "-----",
	"1": ".----",
	"2": "..---",
	"3": "...--",
	"4": "....-",
	"5": ".....",
	"6": "-....",
	"7": "--...",
	"8": "---..",
	"9": "----.",
	"ä": ".-.-",
	"á": ".--.-",
	"å": ".--.-",
	"é": "..-..",
	"ñ": "--.--",
	"ö": "---.",
	"ü": "..--",
	"ç": "-.-..",
	"&": ".-...",
	"'": ".----.",
	"@": ".--.-.",
	")": "-.--.-",
	"(": "-.--.",
	":": "---...",
	",": "--..--",
	"=": "-...-",
	"!": "-.-.--",
	".": ".-.-.-",
	"-": "-....-",
	"+": ".-.-.",
	'"': ".-..-.",
	"?": "..--..",
	"/": "-..-."
};
// swap: make the key the value and vice versa 
MorseCode.dictMorseText = Object.keys(MorseCode.dictTextMorse).reduce((obj, key) => (obj[MorseCode.dictTextMorse[key]] = key, obj),{});

MorseCode.prototype.textToMorse = function(normalText)
{
	return normalText.toLowerCase().split("").map(letter => MorseCode.dictTextMorse[letter] === undefined ? letter : MorseCode.dictTextMorse[letter] + " ").join("");
}

MorseCode.prototype.morseToText = function(morseText)
{
	const text = morseText.split(" ").map(code => MorseCode.dictMorseText[code] === undefined ? (code === "" ? " " : code) : MorseCode.dictMorseText[code]).join("");
	return text.charAt(text.length-1) ===  " " ? text.slice(0, -1) : text;
}

MorseCode.prototype.textHasMorse = function(text)
{
	return text.split(" ").some(code => MorseCode.dictMorseText[code] !== undefined);
}

let morseCode = new MorseCode();