function NonRepetitiveValListGet(list)
{
	this.nub = 0
	this.list = list
}

NonRepetitiveValListGet.prototype.getRandomInt = function (min, max)
{
	return Math.floor(Math.random() * (Math.floor(max) - Math.ceil(min) + 1)) + Math.ceil(min)
}

NonRepetitiveValListGet.prototype.random = function ()
{
	switch (this.list.length)
	{
		case 0: return ''
		case 1: return this.list[0]
		default: return this.list[this.nub = (this.nub + this.getRandomInt(1, this.list.length - 1)) % this.list.length]
	}
}

// bots settings (use Map to preserve bot execution order)
let bots = new Map([
	[
		'mute',
		{
			'name': 'Mute bot',
			'active': false,
			'toggle': function () { this.active = !this.active },
			'location': 'default',
			'msgReact': function (data) { return this.instance.isMuted(data.sender) },
			'init': function () { this.instance = new MutedPlayersClass(`mutedPlayers.${this.location}`); }
		}
	],
	[
		'nub',
		{
			'name': 'Nub bot',
			'active': false,
			'toggle': function () { this.active = !this.active },
			'list': Engine.ReadJSONFile('text_data/nub.json'),
			'msgReact': function (data)
			{
				if (data.receiver != data.sender)
					bots.get('master').sendMessage(`${data.sender} ${this.rand.random()}`);
			},
			'init': function () { this.rand = new NonRepetitiveValListGet(this.list); }
		}
	],
	[
		'noproblemo',
		{
			'name': 'NoProblemo bot',
			'active': false,
			'toggle': function () { this.active = !this.active; },
			'list': Engine.ReadJSONFile('text_data/noproblemo.json'),
			'msgReact': function (data)
			{
				if (data.receiver != data.sender)
					bots.get('master').sendMessage(`${data.sender} ${this.rand.random()}`);
			},
			'init': function () { this.rand = new NonRepetitiveValListGet(this.list); }
		}
	],
	[
		'autociv',
		{
			'name': 'AutoCiv bot',
			'active': false,
			'toggle': function () { this.active = !this.active },
			// customNamesCivs: Mod independent (ignores civs not in current enabled mod).
			// You can add any new civ code name you want from any civ you made.
			// E.g: if you make a new civ called "FoobarCiv", then your civ code will
			// be "foo" and the possible entries ["foo"(civ code added automatically no need to add), "custom name 1", "custom name 2", "custom name N"]
			// Doesn't care if uppercase or lowercase for custom name entries (but yes for the civ code).
			'customNamesCivs': Engine.ReadJSONFile('text_data/civilizations.json'),
			'fuzzySearch': { /* Will be populated by fillFuzzySearch with a FuzzySet instance for each civ code */ },
			'fillFuzzySearch': function (civData)
			{
				this.fuzzySearch = {}
				for (let i = 0; i < civData.code.length; ++i)
				{
					const civCode = civData.code[i]
					// custom names
					let civNames = civCode in this.customNamesCivs ? this.customNamesCivs[civCode] : []
					// oficial name (translated)
					civNames.push(civData.name[i])
					this.fuzzySearch[civCode] = FuzzySet(civNames, true, 3, 3)
				}
			},
			'searchForCivInText': function (text)
			{ // Returns undefined if no civ name is found, otherwise returns the civ code
				return Object.keys(this.fuzzySearch).find(id => !!this.fuzzySearch[id].get(text, false, 0.7))
			},
			'msgReact': function (data)
			{
				if (game.get.players.name().some(name => data.messageFirstWord == name))
					return;

				if (data.messageFirstWord === 'spec')
					game.set.player.observer(data.sender);
				else
					game.set.player.civ(data.sender, this.searchForCivInText(data.messageFirstWord));
			},
			// Depends of the civs the mod has (must follow g_PlayerCivList style of structure)
			'civList': { 'code': [], 'name': [] },
			'init': function () { this.fillFuzzySearch(this.civList); }
		}
	],
	[
		'link',
		{
			'name': 'Text link grabber bot',
			'active': false,
			'toggle': function () { this.active = !this.active; },
			'findAndAdd': function (text) { this.instance.searchTextAndAddUrl(text); },
			'msgReact': function (data) { this.instance.searchTextAndAddUrl(data.message); },
			"init": function () { this.instance = new LinkHandler(); }
		}
	],
	[
		'master',
		{
			'name': 'Master-kun bot',
			'description': 'Handles the others bots stuff',
			'minions': [[]],
			'sendMessage': () => { },
			'init': function ()
			{
				this.minions = Array.from(bots).filter(v => v[0] != "master");
				this.detectMessageInterface();

				for (let [name, bot] of this.minions)
					if (bot.init) bot.init();
			},
			'msgReact': function (data)
			{
				if (!data.message) return;

				let messageFirstWord = data.message.trim().split(" ")[0].toLowerCase();
				data.messageFirstWord = messageFirstWord.length >= 4 ? messageFirstWord : " ";

				for (let [name, bot] of this.minions)
					if (bot.active && bot.msgReact && bot.msgReact(data))
						return true;
			},
			"detectMessageInterface": function ()
			{   // Order matters
				if (Engine.HasNetClient())
					this.sendMessage = text => { if (Engine.HasNetClient()) Engine.SendNetworkChat(text); }
				else if (Engine.HasXmppClient())
					this.sendMessage = text => { if (Engine.HasXmppClient()) Engine.LobbySendMessage(text); }
				else
					this.sendMessage = () => { warn("Can't send messages, disconnected from network!") };
			}
		}
	]
]);