function MutedPlayersClass(config)
{
	this.config = config;
	let text = Engine.ConfigDB_GetValue("user", this.config).slice(1);
	this.list = !!text ? new Set(text.split(",")) : new Set();
}

MutedPlayersClass.prototype.mute = function (userName)
{
	this.list.add(userName); this.save();
};
MutedPlayersClass.prototype.unmute = function (userName)
{
	this.list.delete(userName); this.save();
};
MutedPlayersClass.prototype.isMuted = function (userName)
{
	return this.list.has(userName);
};
MutedPlayersClass.prototype.clear = function ()
{
	this.list.clear(); this.save();
};
MutedPlayersClass.prototype.save = function ()
{
	saveSettingAndWriteToUserConfig(this.config, "+" + Array.from(this.list).join(","));
};
MutedPlayersClass.prototype.stringList = function ()
{
	return Array.from(this.list).join(", ");
};
MutedPlayersClass.prototype.getSize = function ()
{
	return this.list.size;
};
MutedPlayersClass.prototype.getInfo = function ()
{
	return `Muted (${this.list.size}): ${this.stringList()}`;
}