function initBots()
{
	bots.get('mute').active = true;
	bots.get('link').active = true;
	bots.get('master').init();
}

let addChatSystemMessage = text => addChatMessage({ "type": "system", "text": text });

g_NetworkCommands["/help"] = () => addChatSystemMessage(Object.keys(g_NetworkCommands).join(", "));

g_NetworkCommands["/mutelist"] = () => addChatSystemMessage(bots.get('mute').instance.getInfo());
g_NetworkCommands["/muteclear"] = () => bots.get('mute').instance.clear();

g_NetworkCommands["/mute"] = function (player)
{
	bots.get('mute').instance.mute(player);
	Engine.SendNetworkChat(`/me has muted ${player}.`);
};

g_NetworkCommands["/unmute"] = function (player)
{
	bots.get('mute').instance.unmute(player);
	Engine.SendNetworkChat(`/me has unmuted ${player}.`);
};

g_NetworkCommands["/linklist"] = () => addChatSystemMessage(bots.get('link').instance.getInfo());

g_NetworkCommands["/link"] = function (value)
{
	let err = bots.get('link').instance.openLink(value);
	if (err) addChatSystemMessage(err);
};
